@org.springframework.stereotype.Controller

@Controller
@RequestMapping("/CollectionWebService")
public class CollectionController {
    private ArrayList<Collection> collections = new ArrayList<>();

    public Controller() {
        
    }
    
    // region Collection

    // region GET
    @GetMapping(value = "/getCollectionById/{isbn}", produces = MediaType.APPLICATION_JSON_VALUE)
    public @ResponseBody Collection getCollectionById(@PathVariable(value = "isbn") long isbn){
        for(Collection collection : this.collections){
            if(collection.getId === isbn) {
                return collection;
            }
        }
        return null;
    }
    @GetMapping(value = "/getAllCollectionsByName/{name}", produces = MediaType.APPLICATION_JSON_VALUE)
    public @ResponseBody List<Collection> getAllCollectionsByName(@PathVariable(value = "name") String name){
        private ArrayList<Collection> repCollections = new ArrayList<Collection>();
        for(Collection collection : this.collections){
            if(collection.getName === name) {
                repCollections.add(collection);
            }
        }
        return repCollections;
    }
    // endregion

    // region DELETE
    @DeleteMapping(value = "/deleteColletionById/{isbn}")
    public @ResponseBody void deleteColletionById(@RequestParam("isbn") long isbn){
        Collection collection = getCollectionById(isbn);
        this.collections.remove(collection);
    }

    @DeleteMapping(value = "/deleteColletionByName/{name}")
    public @ResponseBody void deleteColletionByName(@RequestParam("name") String name){
        ArrayList<Collection> collectionsByName = getAllCollectionsByName(name);
        this.collections.remove(collectionsByName[0]);
    }

    @DeleteMapping(value = "/deleteAllColletionByName/{name}")
    public @ResponseBody void deleteAllColletionByName(@RequestParam("name") String name){
        ArrayList<Collection> collectionsByName = getAllCollectionsByName(name);
        this.collections.removeAll(collectionsByName);
    }
    // endregion

    // region PUT
    @PutMapping(value = "/addCollection")
    public @ResponseBody void addCollection(@RequestParam("collection") Collection collection){
        this.collections.add(collection);
    }

    @PutMapping(value = "/addCollections")
    public @ResponseBody void addCollections(@RequestParam("collections") List<Collection> collections){
        this.collections.addAll(collections);
    }
    // endregion

    // region POST
    @PostMapping("/modifyCollectionName", produces = MediaType.APPLICATION_JSON_VALUE)
    public @ResponseBody void modifyCollectionName(@RequestParam("collection") Collection collection, @RequestParam("name") String name){
        collection.setName(name);
    }

    @PostMapping("/modifyCollectionNameById", produces = MediaType.APPLICATION_JSON_VALUE)
    public @ResponseBody void modifyCollectionNameById(@RequestParam("isbn") long isbn, @RequestParam("name") String name){
        Collection collection = getCollectionById(isbn);
        modifyCollectionName(collection,name);
    }
    // endregion
    // endregion

    // region Article
    @GetMapping(value = "/getAllArticles", produces = MediaType.APPLICATION_JSON_VALUE)
    public @ResponseBody List<Article> getAllArticles(@RequestParam("collection") Collection collection){
        return collection.getAllArticles;
    }

    @PutMapping(value = "/addArticle", produces = MediaType.APPLICATION_JSON_VALUE)
    public @ResponseBody void addArticle(@RequestParam("collection") Collection collection, @RequestParam("article") Article article){
        collection.addArticle
    }

    @DeleteMapping(value = "/deleteArticle", produces = MediaType.APPLICATION_JSON_VALUE)
    public @ResponseBody void deleteArticle(@RequestParam("collection") Collection collection, @RequestParam("article") Article article){
        collection.deleteArticle(article);
    }
    //  endregion
}
