package SAE.ApiREST.WebService.Data;
@Entity
public class Collection{
    @Id
    @GeneratedValue(strategy=GenerationType.AUTO)
    private final long isbn
    @Column(name = "articles")
    private ArrayList<Article> articles
    @Column(name = "name")
    private String name
    @Column(name = "teacher")
    private Teacher teacher

    public Collection(String name, Teacher teacher){
        this.name = name;
        this.teacher  = teacher;
        this.articles = new ArrayList<Article>();
    }

    // region Article
    public long getId(){
        return isbn;
    }
    // endregion

    // region Article
    public List<Article> getAllArticles(){
        return articles;
    }

    // region addArticle
    public void addArticle(Article article){
        if(!this.articles.contains(article)){
            this.articles.add(article);
        }
    }
    public void addArticles(List<Article> articles){
        for(Article article : articles){
            addArticle(article);
        }
    }
    // endregion

    // region removeArticle
    public void removeArticle(Article article){
        this.articles.remove(article);
    }
    public void removeArticles(List<Article> articles){
        this.articles.removeAll(articles);
    }
    // endregion
    // endregion

    // region name
    public String getName(){
        return name;
    }
    public void setName(String name){
        this.name = name;
    }
    // endregion
}